#!/usr/bin/env python

import micropython.cmd
import rsvp
import sys
import os
from glob import glob

# Main program.

if __name__ == "__main__":
    args = sys.argv[1:]
    path = sys.path[:]
    path.append("tests")

    # Process all tests.

    try:
        _f = args.index("-f")
        filenames = args[_f+1:]
    except ValueError:
        filenames = glob(os.path.join("tests", "*.py"))

    filenames.sort()

    results = []

    for filename in filenames:
        print "Processing", filename

        try:
            p = micropython.cmd.get_program(filename, path, args)
            m = p.get_importer().get_module("__main__")

        # Report any errors.

        except micropython.ProcessingError, exc:
            print repr(exc)
            if "-tb" in args:
                raise

        else:
            rm = rsvp.machine(p)
            success = rm.test(m)
            print "Test successful?", success
            results.append((filename, success))

    print
    for result in results:
        print result

# vim: tabstop=4 expandtab shiftwidth=4
